<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Server settings</title>
  <style>
    body {
      margin: 2rem;
    }

    body.loading main {
      display: none;
    }

    body:not(.loading) #status {
      display: none;
    }

    .container {
      margin: 1rem 0;
    }

    fieldset {
      margin-left: 2rem;
      display: flex;
      flex-direction: column;
      align-items: start;
    }

    fieldset[disabled] {
      opacity: 0.5;
    }

    fieldset>label {
      margin: 0.5rem 0;
    }
  </style>
</head>

<body class="loading">
  <div id="status">loading...</div>
  <main>
    <p>
      Response type:
    </p>
    <form action="">
      <div class="container">
        <label>
          <input type="radio" name="response-type" value="random" />
          random
        </label>
        <fieldset data-type-options="random">
          <label>
            timer [ms]:
            <input type="number" name="timer" min="100" value="3000"/>
          </label>
        </fieldset>
      </div>

      <div class="container">
        <label>
          <input type="radio" name="response-type" value="error" />
          error
        </label>
      </div>

      <div class="container">
        <label>
          <input type="radio" name="response-type" value="modified-data" />
          modified-data
        </label>
        <fieldset data-type-options="modified-data">
          <label>
            maximum amount of quotes:
            <input type="number" name="maxQuotes" min="0" value="10"/>
          </label>
          <label>
            <input type="checkbox" name="setAuthorsAsUnknown" />
            set all authors as "unknown"
          </label>
          <label>
            <input type="checkbox" name="removeTags" />
            remove all tags
          </label>
        </fieldset>
      </div>

      <div class="container">
        <label>
          <input type="radio" name="response-type" value="all-data" />
          all-data
        </label>
      </div>


      <button>Save</button>
      <span id="message"></span>
    </form>
  </main>
  <script>
    const $ = (element, container = document) => container.querySelector(element);
    const $$ = (element, container = document) => container.querySelectorAll(element);
    const inputTypeToValuePropertyNameMap = new Map([["number", "value"], ["checkbox", "checked"]]);

    const form = $("form");
    const message = $("#message");

    let serverSettings = null;
    const serverURL = "http://localhost:3000";

    fetch(`${serverURL}/settings`)
      .then(res => res.json())
      .then(json => {
        console.log("settings received: ", json)
        serverSettings = json;
        updateSettings();
        document.body.classList.toggle("loading", false)

      });

    function updateSettings() {
      const { responseType } = serverSettings;

      const typeElement = $(`[value='${responseType}']`)
      typeElement.checked = true;
      typeElement.dispatchEvent(new Event("change", { bubbles: true }));

      for (const inputElement of $$(`[data-type-options='${responseType}'] input`)) {
        console.log("inputElement", inputElement)
        const valuePropertyName = inputTypeToValuePropertyNameMap.get(inputElement.type);
        console.log("propertyToChange", valuePropertyName)
        inputElement[valuePropertyName] = serverSettings[inputElement.name];
      }

    }

    function enableTypeOptions(typeName) {
      console.log(typeName);
      const containers = document.querySelectorAll("[data-type-options]");

      for (const container of containers) {
        container.toggleAttribute(
          "disabled",
          container.dataset.typeOptions !== typeName,
        );
      }
    }

    addEventListener("change", ({ target }) => {
      message.textContent = "";

      const inputElement = target.closest("input");
      if (!inputElement || inputElement.name !== "response-type") return;

      enableTypeOptions(inputElement.value);
    });

    form.addEventListener("submit", (event) => {
      event.preventDefault();

      const formData = new FormData(form);
      const responseType = formData.get("response-type");

      const body = { responseType };
      for (const inputElement of $$(`[data-type-options='${responseType}'] input`)) {
        const valuePropertyName = inputTypeToValuePropertyNameMap.get(inputElement.type)
        body[inputElement.name] = inputElement[valuePropertyName]
      }

      fetch(`${serverURL}/settings`, {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify(body),
      })
        .then(res => message.textContent = "Success!")
        .catch(err => message.textContent = "Failure!");
    });
  </script>
</body>

</html>